import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import java.io.File;
import java.io.IOException;

public class ExtractJMeterParameterDetails {

    public static void main(String[] args) throws ParserConfigurationException, IOException, SAXException {

        // Instantiate the Factory
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();

        // Create document builder
        DocumentBuilder db = dbf.newDocumentBuilder();

        // Load the test from the script directory
        Document doc = db.parse(new File("script/OctoPerf_Test_Parser.jmx"));

        // Optional, but recommended
        doc.getDocumentElement().normalize();

        // Get the top level node and iterate all nodes
        NodeList topLevelNodeList = doc.getElementsByTagName("*");
        for (int i = 0; i < topLevelNodeList.getLength(); i++) {
            Node nodeTop = topLevelNodeList.item(i);
            NodeList nodeChildren = nodeTop.getChildNodes();
            for(int a=0; a < nodeChildren.getLength(); a++) {
                Node node = nodeChildren.item(a);
                if(node.getNodeName().equals("HTTPSamplerProxy")) {
                    NamedNodeMap samplerMainAttributes = node.getAttributes();
                    for (int j = 0; j < samplerMainAttributes.getLength(); j++) {
                        if(samplerMainAttributes.item(j).getNodeName().equals("testname")) {
                            if(samplerMainAttributes.item(j).getNodeValue().equals("sampler_4")) {
                                NodeList childNodes = node.getChildNodes();
                                for (int k = 0; k < childNodes.getLength(); k++) {
                                    if(childNodes.item(k).getNodeName().equals("elementProp")) {
                                        NodeList childchildNodes = childNodes.item(k).getChildNodes();
                                        for (int l = 0; l < childchildNodes.getLength(); l++) {
                                            if(childchildNodes.item(l).getNodeName().equals("collectionProp")) {
                                                NodeList childchildchildNodes = childchildNodes.item(l).getChildNodes();
                                                for (int m = 0; m < childchildchildNodes.getLength(); m++) {
                                                    if(childchildchildNodes.item(m).getNodeName().equals("elementProp")) {
                                                        if (childchildchildNodes.item(m).hasAttributes()) {
                                                            NamedNodeMap samplerChildAttributes = childchildchildNodes.item(m).getAttributes();
                                                            for (int n = 0; n < samplerChildAttributes.getLength(); n++) {
                                                                if (samplerChildAttributes.item(n).getNodeName().equals("name")) {
                                                                    System.out.println("Parameter = " + samplerChildAttributes.item(n).getNodeValue());
                                                                    NodeList childchildchildchildNodes = childchildchildNodes.item(m).getChildNodes();
                                                                    for (int o = 0; o < childchildchildchildNodes.getLength(); o++) {
                                                                        if (childchildchildchildNodes.item(o).hasAttributes()) {
                                                                            NamedNodeMap elementChildAttributes = childchildchildchildNodes.item(o).getAttributes();
                                                                            for (int p = 0; p < elementChildAttributes.getLength(); p++) {
                                                                                if (elementChildAttributes.item(p).getNodeValue().equals("Argument.value")) {
                                                                                    System.out.println("Value = " + childchildchildchildNodes.item(o).getTextContent());
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}
