import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import java.io.File;
import java.io.IOException;

public class ExtractJMeterPreProcessorDetails {

    public static void main(String[] args) throws ParserConfigurationException, IOException, SAXException {

        // Instantiate the Factory
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();

        // Create document builder
        DocumentBuilder db = dbf.newDocumentBuilder();

        // Load the test from the script directory
        Document doc = db.parse(new File("script/OctoPerf_Test_Parser.jmx"));

        // Optional, but recommended
        doc.getDocumentElement().normalize();

        // Get the top level node and iterate all nodes
        NodeList topLevelNodeList = doc.getElementsByTagName("*");
        for (int i = 0; i < topLevelNodeList.getLength(); i++) {
            Node nodeTop = topLevelNodeList.item(i);
            NodeList nodeChildren = nodeTop.getChildNodes();
            for(int a=0; a < nodeChildren.getLength(); a++) {
                Node node = nodeChildren.item(a);
                if(node.getNodeName().equals("HTTPSamplerProxy")) {
                    NamedNodeMap samplerMainAttributes = node.getAttributes();
                    for (int j = 0; j < samplerMainAttributes.getLength(); j++) {
                        if(samplerMainAttributes.item(j).getNodeName().equals("testname")) {
                            //System.out.println("Sampler Name = " + samplerMainAttributes.item(j).getNodeValue());
                        }
                    }
                }
                if(node.getNodeName().equals("JSR223PreProcessor")) {
                    NamedNodeMap samplerMainAttributes = node.getAttributes();
                    for (int j = 0; j < samplerMainAttributes.getLength(); j++) {
                        if (samplerMainAttributes.item(j).getNodeName().equals("testname")) {
                            System.out.println("PreProcessor Name = " + samplerMainAttributes.item(j).getNodeValue());
                            NodeList childNodes = node.getChildNodes();
                            for (int k = 0; k < childNodes.getLength(); k++) {
                                if (childNodes.item(k).hasAttributes()) {
                                    NamedNodeMap samplerChildAttributes = childNodes.item(k).getAttributes();
                                    for (int l = 0; l < samplerChildAttributes.getLength(); l++) {
                                        if (samplerChildAttributes.item(l).getNodeName().equals("name")) {
                                            if (samplerChildAttributes.item(l).getNodeValue().equals("script")) {
                                                //System.out.println("Script = " + childNodes.item(k).getTextContent());
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                if(node.getNodeName().equals("JDBCPreProcessor")) {
                    NamedNodeMap samplerMainAttributes = node.getAttributes();
                    for (int j = 0; j < samplerMainAttributes.getLength(); j++) {
                        if (samplerMainAttributes.item(j).getNodeName().equals("testname")) {
                            //System.out.println("PreProcessor Name = " + samplerMainAttributes.item(j).getNodeValue());
                        }
                    }
                }
                if(node.getNodeName().equals("RegexExtractor")) {
                    NamedNodeMap samplerMainAttributes = node.getAttributes();
                    for (int j = 0; j < samplerMainAttributes.getLength(); j++) {
                        if(samplerMainAttributes.item(j).getNodeName().equals("testname")) {
                            //System.out.println("PostProcessor Name = " + samplerMainAttributes.item(j).getNodeValue());
                        }
                    }
                    System.out.println("------------------------------------------");
                }
            }
        }
    }
}
