import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import java.io.File;
import java.io.IOException;

public class ExtractJMeterTestDetails {

    public static void main(String[] args) throws ParserConfigurationException, IOException, SAXException, TransformerException {

        // Instantiate the Factory
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();

        // Create document builder
        DocumentBuilder db = dbf.newDocumentBuilder();

        // Load the test from the script directory
        Document doc = db.parse(new File("script/OctoPerf_Test_Parser.jmx"));

        // Optional, but recommended
        doc.getDocumentElement().normalize();

        // Get the top level node and iterate all nodes
        NodeList topLevelNodeList = doc.getElementsByTagName("*");
        for (int i = 0; i < topLevelNodeList.getLength(); i++) {
            Node nodeTop = topLevelNodeList.item(i);
            NodeList nodeChildren = nodeTop.getChildNodes();
            for(int a=0; a < nodeChildren.getLength(); a++) {
                Node node = nodeChildren.item(a);
                if(node.getNodeName().equals("HTTPSamplerProxy")) {
                    NamedNodeMap samplerMainAttributes = node.getAttributes();
                    for (int j = 0; j < samplerMainAttributes.getLength(); j++) {
                        if(samplerMainAttributes.item(j).getNodeName().equals("testname")) {
                            System.out.println("Sampler Name = " + samplerMainAttributes.item(j).getNodeValue());
                        }
                    }
                    NodeList childNodes = node.getChildNodes();
                    for (int k = 0; k < childNodes.getLength(); k++) {
                        if (childNodes.item(k).hasAttributes()) {
                            NamedNodeMap samplerChildAttributes = childNodes.item(k).getAttributes();
                            for (int l = 0; l < samplerChildAttributes.getLength(); l++) {
                                if (samplerChildAttributes.item(l).getNodeName().equals("name")) {
                                    if (samplerChildAttributes.item(l).getNodeValue().equals("HTTPSampler.domain")) {
                                        childNodes.item(k).setTextContent("$P{__(serverName)}");
                                        System.out.println("Server Name of IP = " + childNodes.item(k).getTextContent());
                                    }
                                    if (samplerChildAttributes.item(l).getNodeValue().equals("HTTPSampler.path")) {
                                        String currentPath = childNodes.item(k).getTextContent();
                                        childNodes.item(k).setTextContent(currentPath.replace("test_enpoint", "new_test_endpoint"));
                                        System.out.println("Path = " + childNodes.item(k).getTextContent());
                                    }
                                    if (samplerChildAttributes.item(l).getNodeValue().equals("HTTPSampler.port")) {
                                        System.out.println("Port Number = " + childNodes.item(k).getTextContent());
                                    }
                                    if (samplerChildAttributes.item(l).getNodeValue().equals("HTTPSampler.protocol")) {
                                        System.out.println("Protocol = " + childNodes.item(k).getTextContent());
                                    }
                                    if (samplerChildAttributes.item(l).getNodeValue().equals("HTTPSampler.method")) {
                                        System.out.println("Method = " + childNodes.item(k).getTextContent());
                                    }
                                }
                            }
                        }
                    }
                    System.out.println("------------------------------------------");
                }
            }
        }

        // Create a new test from the updated XML
        TransformerFactory factory = TransformerFactory.newInstance();
        Transformer transformer = factory.newTransformer();

        DOMSource source = new DOMSource(doc);
        StreamResult result = new StreamResult(new File("script/OctoPerf_Test_Parser_New.jmx"));
        transformer.transform(source, result);
    }
}
